diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/network/bindings/modulegen__gcc_LP64.py ns-3.31/src/network/bindings/modulegen__gcc_LP64.py
--- ns-3.30.1/src/network/bindings/modulegen__gcc_LP64.py	2019-08-12 17:00:27.000000000 -0700
+++ ns-3.31/src/network/bindings/modulegen__gcc_LP64.py	2020-06-27 17:38:30.000000000 -0700
@@ -10219,22 +10252,22 @@
     cls.add_method('Enqueue', 
                    'bool', 
                    [param('ns3::Ptr< ns3::Packet >', 'item')], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     ## queue.h (module 'network'): ns3::Ptr<ns3::Packet> ns3::Queue<ns3::Packet>::Dequeue() [member function]
     cls.add_method('Dequeue', 
                    'ns3::Ptr< ns3::Packet >', 
                    [], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     ## queue.h (module 'network'): ns3::Ptr<ns3::Packet> ns3::Queue<ns3::Packet>::Remove() [member function]
     cls.add_method('Remove', 
                    'ns3::Ptr< ns3::Packet >', 
                    [], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     ## queue.h (module 'network'): ns3::Ptr<const ns3::Packet> ns3::Queue<ns3::Packet>::Peek() const [member function]
     cls.add_method('Peek', 
                    'ns3::Ptr< ns3::Packet const >', 
                    [], 
-                   is_const=True, is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_const=True, is_virtual=True)
     ## queue.h (module 'network'): void ns3::Queue<ns3::Packet>::Flush() [member function]
     cls.add_method('Flush', 
                    'void', 
@@ -10305,22 +10338,22 @@
     cls.add_method('Enqueue', 
                    'bool', 
                    [param('ns3::Ptr< ns3::QueueDiscItem >', 'item')], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     ## queue.h (module 'network'): ns3::Ptr<ns3::QueueDiscItem> ns3::Queue<ns3::QueueDiscItem>::Dequeue() [member function]
     cls.add_method('Dequeue', 
                    'ns3::Ptr< ns3::QueueDiscItem >', 
                    [], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     ## queue.h (module 'network'): ns3::Ptr<ns3::QueueDiscItem> ns3::Queue<ns3::QueueDiscItem>::Remove() [member function]
     cls.add_method('Remove', 
                    'ns3::Ptr< ns3::QueueDiscItem >', 
                    [], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     ## queue.h (module 'network'): ns3::Ptr<const ns3::QueueDiscItem> ns3::Queue<ns3::QueueDiscItem>::Peek() const [member function]
     cls.add_method('Peek', 
                    'ns3::Ptr< ns3::QueueDiscItem const >', 
                    [], 
-                   is_const=True, is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_const=True, is_virtual=True)
     ## queue.h (module 'network'): void ns3::Queue<ns3::QueueDiscItem>::Flush() [member function]
     cls.add_method('Flush', 
                    'void', 
@@ -10485,27 +10518,27 @@
     cls.add_method('DoCorrupt', 
                    'bool', 
                    [param('ns3::Ptr< ns3::Packet >', 'p')], 
-                   is_virtual=True, visibility='private')
+                   visibility='private', is_virtual=True)
     ## error-model.h (module 'network'): bool ns3::RateErrorModel::DoCorruptBit(ns3::Ptr<ns3::Packet> p) [member function]
     cls.add_method('DoCorruptBit', 
                    'bool', 
                    [param('ns3::Ptr< ns3::Packet >', 'p')], 
-                   is_virtual=True, visibility='private')
+                   visibility='private', is_virtual=True)
     ## error-model.h (module 'network'): bool ns3::RateErrorModel::DoCorruptByte(ns3::Ptr<ns3::Packet> p) [member function]
     cls.add_method('DoCorruptByte', 
                    'bool', 
                    [param('ns3::Ptr< ns3::Packet >', 'p')], 
-                   is_virtual=True, visibility='private')
+                   visibility='private', is_virtual=True)
     ## error-model.h (module 'network'): bool ns3::RateErrorModel::DoCorruptPkt(ns3::Ptr<ns3::Packet> p) [member function]
     cls.add_method('DoCorruptPkt', 
                    'bool', 
                    [param('ns3::Ptr< ns3::Packet >', 'p')], 
-                   is_virtual=True, visibility='private')
+                   visibility='private', is_virtual=True)
     ## error-model.h (module 'network'): void ns3::RateErrorModel::DoReset() [member function]
     cls.add_method('DoReset', 
                    'void', 
                    [], 
-                   is_virtual=True, visibility='private')
+                   visibility='private', is_virtual=True)
     return
 
 def register_Ns3ReceiveListErrorModel_methods(root_module, cls):
@@ -10531,12 +10564,12 @@
     cls.add_method('DoCorrupt', 
                    'bool', 
                    [param('ns3::Ptr< ns3::Packet >', 'p')], 
-                   is_virtual=True, visibility='private')
+                   visibility='private', is_virtual=True)
     ## error-model.h (module 'network'): void ns3::ReceiveListErrorModel::DoReset() [member function]
     cls.add_method('DoReset', 
                    'void', 
                    [], 
-                   is_virtual=True, visibility='private')
+                   visibility='private', is_virtual=True)
     return
 
 def register_Ns3SimpleChannel_methods(root_module, cls):
@@ -10736,7 +10769,7 @@
     cls.add_method('DoDispose', 
                    'void', 
                    [], 
-                   is_virtual=True, visibility='protected')
+                   visibility='protected', is_virtual=True)
     return
 
 def register_Ns3TimeValue_methods(root_module, cls):
@@ -10899,12 +10932,12 @@
     cls.add_method('DoCorrupt', 
                    'bool', 
                    [param('ns3::Ptr< ns3::Packet >', 'p')], 
-                   is_virtual=True, visibility='private')
+                   visibility='private', is_virtual=True)
     ## error-model.h (module 'network'): void ns3::BinaryErrorModel::DoReset() [member function]
     cls.add_method('DoReset', 
                    'void', 
                    [], 
-                   is_virtual=True, visibility='private')
+                   visibility='private', is_virtual=True)
     return
 
 def register_Ns3BurstErrorModel_methods(root_module, cls):
@@ -10942,12 +10975,12 @@
     cls.add_method('DoCorrupt', 
                    'bool', 
                    [param('ns3::Ptr< ns3::Packet >', 'p')], 
-                   is_virtual=True, visibility='private')
+                   visibility='private', is_virtual=True)
     ## error-model.h (module 'network'): void ns3::BurstErrorModel::DoReset() [member function]
     cls.add_method('DoReset', 
                    'void', 
                    [], 
-                   is_virtual=True, visibility='private')
+                   visibility='private', is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Bool_Ns3Ptr__lt__ns3NetDevice__gt___Ns3Ptr__lt__const_ns3Packet__gt___Unsigned_short_Const_ns3Address___amp___Const_ns3Address___amp___Ns3NetDevicePacketType_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -10969,7 +11002,7 @@
     cls.add_method('operator()', 
                    'bool', 
                    [param('ns3::Ptr< ns3::NetDevice >', 'arg0'), param('ns3::Ptr< ns3::Packet const >', 'arg1'), param('short unsigned int', 'arg2'), param('ns3::Address const &', 'arg3'), param('ns3::Address const &', 'arg4'), param('ns3::NetDevice::PacketType', 'arg5')], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Bool_Ns3Ptr__lt__ns3NetDevice__gt___Ns3Ptr__lt__const_ns3Packet__gt___Unsigned_short_Const_ns3Address___amp___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -10991,7 +11024,7 @@
     cls.add_method('operator()', 
                    'bool', 
                    [param('ns3::Ptr< ns3::NetDevice >', 'arg0'), param('ns3::Ptr< ns3::Packet const >', 'arg1'), param('short unsigned int', 'arg2'), param('ns3::Address const &', 'arg3')], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Bool_Ns3Ptr__lt__ns3Socket__gt___Const_ns3Address___amp___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -11013,7 +11046,7 @@
     cls.add_method('operator()', 
                    'bool', 
                    [param('ns3::Ptr< ns3::Socket >', 'arg0'), param('ns3::Address const &', 'arg1')], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Ns3ObjectBase___star___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -11035,7 +11068,7 @@
     cls.add_method('operator()', 
                    'ns3::ObjectBase *', 
                    [], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__const_ns3Packet__gt___Const_ns3Address___amp___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -11057,7 +11090,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::Packet const >', 'arg0'), param('ns3::Address const &', 'arg1')], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__const_ns3Packet__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -11079,7 +11112,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::Packet const >', 'arg0')], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__const_ns3QueueDiscItem__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -11101,7 +11134,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::QueueDiscItem const >', 'arg0')], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3NetDevice__gt___Ns3Ptr__lt__const_ns3Packet__gt___Unsigned_short_Const_ns3Address___amp___Const_ns3Address___amp___Ns3NetDevicePacketType_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -11123,7 +11156,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::NetDevice >', 'arg0'), param('ns3::Ptr< ns3::Packet const >', 'arg1'), param('short unsigned int', 'arg2'), param('ns3::Address const &', 'arg3'), param('ns3::Address const &', 'arg4'), param('ns3::NetDevice::PacketType', 'arg5')], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3NetDevice__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -11145,7 +11178,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::NetDevice >', 'arg0')], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3Socket__gt___Const_ns3Address___amp___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -11167,7 +11200,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::Socket >', 'arg0'), param('ns3::Address const &', 'arg1')], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3Socket__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -11189,7 +11222,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::Socket >', 'arg0')], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3Socket__gt___Unsigned_int_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -11211,7 +11244,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::Socket >', 'arg0'), param('unsigned int', 'arg1')], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -11233,7 +11266,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Unsigned_int_Unsigned_int_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -11255,7 +11288,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('unsigned int', 'arg0'), param('unsigned int', 'arg1')], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CounterCalculator__Unsigned_int_methods(root_module, cls):
@@ -11290,7 +11323,7 @@
     cls.add_method('DoDispose', 
                    'void', 
                    [], 
-                   is_virtual=True, visibility='protected')
+                   visibility='protected', is_virtual=True)
     return
 
 def register_Ns3DropTailQueue__Ns3Packet_methods(root_module, cls):
@@ -11427,7 +11460,7 @@
     cls.add_method('DoDispose', 
                    'void', 
                    [], 
-                   is_virtual=True, visibility='protected')
+                   visibility='protected', is_virtual=True)
     return
 
 def register_Ns3PacketProbe_methods(root_module, cls):
@@ -11540,7 +11573,7 @@
     cls.add_method('AddHeader', 
                    'void', 
                    [], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     ## queue-item.h (module 'network'): void ns3::QueueDiscItem::Print(std::ostream & os) const [member function]
     cls.add_method('Print', 
                    'void', 
@@ -11550,7 +11583,7 @@
     cls.add_method('Mark', 
                    'bool', 
                    [], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     ## queue-item.h (module 'network'): uint32_t ns3::QueueDiscItem::Hash(uint32_t perturbation=0) const [member function]
     cls.add_method('Hash', 
                    'uint32_t', 
@@ -11567,7 +11600,7 @@
     cls.add_method('GetHash32', 
                    'uint32_t', 
                    [param('char const *', 'buffer'), param('std::size_t const', 'size')], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     ## hash-function.h (module 'core'): uint64_t ns3::Hash::Implementation::GetHash64(char const * buffer, std::size_t const size) [member function]
     cls.add_method('GetHash64', 
                    'uint64_t', 
@@ -11577,7 +11610,7 @@
     cls.add_method('clear', 
                    'void', 
                    [], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3HashFunctionFnv1a_methods(root_module, cls):
@@ -11705,6 +11738,11 @@
     module.add_function('MakeMac64AddressChecker', 
                         'ns3::Ptr< ns3::AttributeChecker const >', 
                         [])
+    ## queue-size.h (module 'network'): ns3::Ptr<const ns3::AttributeAccessor> ns3::MakeQueueSizeAccessor(void ( ::ns3::QueueBase::* )( ::ns3::QueueSize ) a1, ns3::QueueSize ( ::ns3::QueueBase::* )(  )const a2) [free function]
+    module.add_function('MakeQueueSizeAccessor', 
+                        'ns3::Ptr< ns3::AttributeAccessor const >', 
+                        [param('void ( ns3::QueueBase:: * ) ( ns3::QueueSize )', 'a1'), param('ns3::QueueSize ( ns3::QueueBase:: * ) (  ) const', 'a2')], 
+                        template_parameters=['void (ns3::QueueBase::*)(ns3::QueueSize)', ' ns3::QueueSize (ns3::QueueBase::*)() const'])
     ## queue-size.h (module 'network'): ns3::Ptr<const ns3::AttributeChecker> ns3::MakeQueueSizeChecker() [free function]
     module.add_function('MakeQueueSizeChecker', 
                         'ns3::Ptr< ns3::AttributeChecker const >', 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/network/examples/packet-socket-apps.cc ns-3.31/src/network/examples/packet-socket-apps.cc
--- ns-3.30.1/src/network/examples/packet-socket-apps.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/network/examples/packet-socket-apps.cc	2020-06-27 17:38:30.000000000 -0700
@@ -40,7 +40,7 @@
 {
   bool verbose = false;
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("verbose", "turn on log components", verbose);
   cmd.Parse(argc, argv);
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/network/helper/delay-jitter-estimation.cc ns-3.31/src/network/helper/delay-jitter-estimation.cc
--- ns-3.30.1/src/network/helper/delay-jitter-estimation.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/network/helper/delay-jitter-estimation.cc	2020-06-27 17:38:30.000000000 -0700
@@ -53,11 +53,11 @@
    */
   Time GetTxTime (void) const;
 private:
-  uint64_t m_creationTime; //!< The time stored in the tag
+  Time m_creationTime; //!< The time stored in the tag
 };
 
 DelayJitterEstimationTimestampTag::DelayJitterEstimationTimestampTag ()
-  : m_creationTime (Simulator::Now ().GetTimeStep ())
+  : m_creationTime (Simulator::Now ())
 {
 }
 
@@ -70,8 +70,8 @@
     .AddConstructor<DelayJitterEstimationTimestampTag> ()
     .AddAttribute ("CreationTime",
                    "The time at which the timestamp was created",
-                   StringValue ("0.0s"),
-                   MakeTimeAccessor (&DelayJitterEstimationTimestampTag::GetTxTime),
+                   TimeValue (Time (0)),
+                   MakeTimeAccessor (&DelayJitterEstimationTimestampTag::m_creationTime),
                    MakeTimeChecker ())
   ;
   return tid;
@@ -90,12 +90,12 @@
 void
 DelayJitterEstimationTimestampTag::Serialize (TagBuffer i) const
 {
-  i.WriteU64 (m_creationTime);
+  i.WriteU64 (m_creationTime.GetTimeStep ());
 }
 void
 DelayJitterEstimationTimestampTag::Deserialize (TagBuffer i)
 {
-  m_creationTime = i.ReadU64 ();
+  m_creationTime = TimeStep (i.ReadU64 ());
 }
 void
 DelayJitterEstimationTimestampTag::Print (std::ostream &os) const
@@ -105,14 +105,12 @@
 Time
 DelayJitterEstimationTimestampTag::GetTxTime (void) const
 {
-  return TimeStep (m_creationTime);
+  return m_creationTime;
 }
 
 DelayJitterEstimation::DelayJitterEstimation ()
-  : m_previousRx (Simulator::Now ()),
-    m_previousRxTx (Simulator::Now ()),
-    m_jitter (0),
-    m_delay (Seconds (0.0))
+  : m_jitter (Time (0)),
+    m_transit (Time (0))
 {
 }
 void
@@ -131,24 +129,37 @@
     {
       return;
     }
-  tag.GetTxTime ();
 
-  Time delta = (Simulator::Now () - m_previousRx) - (tag.GetTxTime () - m_previousRxTx);
-  m_jitter += (Abs (delta) - m_jitter) / (int64x64_t)16;
-  m_previousRx = Simulator::Now ();
-  m_previousRxTx = tag.GetTxTime ();
-  m_delay = Simulator::Now () - tag.GetTxTime ();
+  // Variable names from
+  // RFC 1889 Appendix A.8 ,p. 71,
+  // RFC 3550 Appendix A.8, p. 94
+  
+  Time r_ts = tag.GetTxTime ();
+  Time arrival = Simulator::Now ();
+  Time transit = arrival - r_ts;
+  Time delta = transit - m_transit;
+  m_transit = transit;
+
+  // floating jitter version
+  //  m_jitter += (Abs (delta) - m_jitter) / 16;
+  
+  // int variant
+  m_jitter += Abs (delta) - ( (m_jitter + TimeStep (8)) / 16 );
 }
 
 Time 
 DelayJitterEstimation::GetLastDelay (void) const
 {
-  return m_delay;
+  return m_transit;
 }
 uint64_t
 DelayJitterEstimation::GetLastJitter (void) const
 {
-  return m_jitter.GetHigh ();
+  // floating jitter version
+  // return m_jitter.GetTimeStep ();
+
+  // int variant
+  return (m_jitter / 16).GetTimeStep ();
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/network/helper/delay-jitter-estimation.h ns-3.31/src/network/helper/delay-jitter-estimation.h
--- ns-3.30.1/src/network/helper/delay-jitter-estimation.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/network/helper/delay-jitter-estimation.h	2020-06-27 17:38:30.000000000 -0700
@@ -28,8 +28,13 @@
 /**
  * \ingroup stats
  *
- * \brief quick and dirty delay and jitter estimation
+ * \brief Quick and dirty delay and jitter estimation,
+ * implementing the jitter algorithm originally from
+ * \RFC{1889} (RTP), and unchanged in \RFC(3550) 
  *
+ * This implementation uses the integer variant of the algorithm
+ * given in RFC 1889 Appendix A.8 ,p. 71, and repeated in
+ * RFC 3550 Appendix A.8, p. 94.
  */
 class DelayJitterEstimation
 {
@@ -69,10 +74,8 @@
   uint64_t GetLastJitter (void) const;
 
 private:
-  Time m_previousRx;   //!< Previous Rx time
-  Time m_previousRxTx; //!< Previous Rx or Tx time
-  int64x64_t m_jitter; //!< Jitter estimation
-  Time m_delay;        //!< Delay estimation
+  Time m_jitter;       //!< Jitter estimation
+  Time m_transit;      //!< Relative transit time for the previous packet
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/network/helper/node-container.cc ns-3.31/src/network/helper/node-container.cc
--- ns-3.30.1/src/network/helper/node-container.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/network/helper/node-container.cc	2020-06-27 17:38:30.000000000 -0700
@@ -36,6 +36,11 @@
   Ptr<Node> node = Names::Find<Node> (nodeName);
   m_nodes.push_back (node);
 }
+NodeContainer::NodeContainer (uint32_t n, uint32_t systemId /* = 0 */)
+{
+  m_nodes.reserve (n);
+  Create (n, systemId);
+}
 NodeContainer::NodeContainer (const NodeContainer &a, const NodeContainer &b)
 {
   Add (a);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/network/helper/node-container.h ns-3.31/src/network/helper/node-container.h
--- ns-3.30.1/src/network/helper/node-container.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/network/helper/node-container.h	2020-06-27 17:38:30.000000000 -0700
@@ -64,6 +64,20 @@
   NodeContainer (std::string nodeName);
 
   /**
+   * Create a NodeContainer with the requested number of Nodes.
+   *
+   * This is syntatic sugar for
+   *
+   *     NodeContainer nodes;
+   *     nodes.Create (size);
+   *     // or nodes.Create (size, systemId);
+   *
+   * \param [in] n The number of nodes to create.
+   * \param [in] systemId The system id or rank associated with this node
+   */
+  NodeContainer (uint32_t n, uint32_t systemId = 0);
+  
+  /**
    * Create a node container which is a concatenation of two input
    * NodeContainers.
    *
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/network/model/node.cc ns-3.31/src/network/model/node.cc
--- ns-3.30.1/src/network/model/node.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/network/model/node.cc	2020-06-27 17:38:30.000000000 -0700
@@ -39,6 +39,8 @@
 NS_OBJECT_ENSURE_REGISTERED (Node);
 
 /**
+ * \relates Node
+ * \anchor GlobalValueChecksumEnabled
  * \brief A global switch to enable all checksums for all protocols.
  */
 static GlobalValue g_checksumEnabled  = GlobalValue ("ChecksumEnabled",
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/network/test/pcap-file-test-suite.cc ns-3.31/src/network/test/pcap-file-test-suite.cc
--- ns-3.30.1/src/network/test/pcap-file-test-suite.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/network/test/pcap-file-test-suite.cc	2020-06-27 17:38:30.000000000 -0700
@@ -844,8 +844,8 @@
 
   f.Read (bufferIn, sizeof(bufferIn), tsSec, tsUsec, inclLen, origLen, readLen);
   NS_TEST_ASSERT_MSG_EQ (f.Fail (), false, "Read() of known good packet returns error");
-  NS_TEST_ASSERT_MSG_EQ (tsSec, 1234, "Incorrectly read seconds timestap from known good packet");
-  NS_TEST_ASSERT_MSG_EQ (tsUsec, 5678, "Incorrectly read microseconds timestap from known good packet");
+  NS_TEST_ASSERT_MSG_EQ (tsSec, 1234, "Incorrectly read seconds timestamp from known good packet");
+  NS_TEST_ASSERT_MSG_EQ (tsUsec, 5678, "Incorrectly read microseconds timestamp from known good packet");
   NS_TEST_ASSERT_MSG_EQ (inclLen, 43, "Incorrectly read included length from known good packet");
   NS_TEST_ASSERT_MSG_EQ (origLen, 128, "Incorrectly read original length from known good packet");
   NS_TEST_ASSERT_MSG_EQ (readLen, 43, "Incorrectly constructed actual read length from known good packet given buffer size");
@@ -953,8 +953,8 @@
 
   f.Read (bufferIn, sizeof(bufferIn), tsSec, tsUsec, inclLen, origLen, readLen);
   NS_TEST_ASSERT_MSG_EQ (f.Fail (), false, "Read() of known good packet returns error");
-  NS_TEST_ASSERT_MSG_EQ (tsSec, 1234, "Incorrectly read seconds timestap from known good packet");
-  NS_TEST_ASSERT_MSG_EQ (tsUsec, 5678, "Incorrectly read microseconds timestap from known good packet");
+  NS_TEST_ASSERT_MSG_EQ (tsSec, 1234, "Incorrectly read seconds timestamp from known good packet");
+  NS_TEST_ASSERT_MSG_EQ (tsUsec, 5678, "Incorrectly read microseconds timestamp from known good packet");
   NS_TEST_ASSERT_MSG_EQ (inclLen, 43, "Incorrectly read included length from known good packet");
   NS_TEST_ASSERT_MSG_EQ (origLen, 128, "Incorrectly read original length from known good packet");
   NS_TEST_ASSERT_MSG_EQ (readLen, 43, "Incorrectly constructed actual read length from known good packet given buffer size");
@@ -1120,7 +1120,7 @@
   //
   // Create different PCAP file (with the same timestamps, but different packets) and check that it is indeed different 
   //
-  std::string filename2 = "different.pcap";
+  std::string filename2 = CreateTempDirFilename ("different.pcap");
   PcapFile f;
 
   f.Open (filename2, std::ios::out);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/network/utils/data-rate.cc ns-3.31/src/network/utils/data-rate.cc
--- ns-3.30.1/src/network/utils/data-rate.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/network/utils/data-rate.cc	2020-06-27 17:38:30.000000000 -0700
@@ -226,12 +226,6 @@
   return m_bps!=rhs.m_bps;
 }
 
-double DataRate::CalculateTxTime (uint32_t bytes) const
-{
-  NS_LOG_FUNCTION (this << bytes);
-  return static_cast<double>(bytes)*8/m_bps;
-}
-
 Time DataRate::CalculateBytesTxTime (uint32_t bytes) const
 {
   NS_LOG_FUNCTION (this << bytes);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/network/utils/data-rate.h ns-3.31/src/network/utils/data-rate.h
--- ns-3.30.1/src/network/utils/data-rate.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/network/utils/data-rate.h	2020-06-27 17:38:30.000000000 -0700
@@ -179,19 +179,6 @@
   Time CalculateBitsTxTime (uint32_t bits) const;
 
   /**
-   * \brief Calculate transmission time
-   *
-   * Calculates the transmission time at this data rate
-   * \param bytes The number of bytes (not bits) for which to calculate
-   * \return The transmission time in seconds for the number of bytes specified
-   *
-   * \deprecated This method will go away in future versions of ns-3.
-   * See instead CalculateBytesTxTime()
-   */
-  NS_DEPRECATED
-  double CalculateTxTime (uint32_t bytes) const;
-
-  /**
    * Get the underlying bitrate
    * \return The underlying bitrate in bits per second
    */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/network/utils/drop-tail-queue.h ns-3.31/src/network/utils/drop-tail-queue.h
--- ns-3.30.1/src/network/utils/drop-tail-queue.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/network/utils/drop-tail-queue.h	2020-06-27 17:38:30.000000000 -0700
@@ -75,6 +75,12 @@
     .SetParent<Queue<Item> > ()
     .SetGroupName ("Network")
     .template AddConstructor<DropTailQueue<Item> > ()
+    .AddAttribute ("MaxSize",
+                   "The max queue size",
+                   QueueSizeValue (QueueSize ("100p")),
+                   MakeQueueSizeAccessor (&QueueBase::SetMaxSize,
+                                          &QueueBase::GetMaxSize),
+                   MakeQueueSizeChecker ())
   ;
   return tid;
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/network/utils/ipv4-address.cc ns-3.31/src/network/utils/ipv4-address.cc
--- ns-3.30.1/src/network/utils/ipv4-address.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/network/utils/ipv4-address.cc	2020-06-27 17:38:30.000000000 -0700
@@ -197,9 +197,10 @@
   return tmp; 
 }
 
+static constexpr uint32_t UNINITIALIZED = 0x66666666U;
 
 Ipv4Address::Ipv4Address ()
-  : m_address (0x66666666)
+  : m_address (UNINITIALIZED), m_initialized (false)
 {
   NS_LOG_FUNCTION (this);
 }
@@ -207,11 +208,13 @@
 {
   NS_LOG_FUNCTION (this << address);
   m_address = address;
+  m_initialized = true;
 }
 Ipv4Address::Ipv4Address (char const *address)
 {
   NS_LOG_FUNCTION (this << address);
   m_address = AsciiToIpv4Host (address);
+  m_initialized = true;
 }
 
 uint32_t
@@ -225,12 +228,14 @@
 {
   NS_LOG_FUNCTION (this << address);
   m_address = address;
+  m_initialized = true;
 }
 void
 Ipv4Address::Set (char const *address)
 {
   NS_LOG_FUNCTION (this << address);
   m_address = AsciiToIpv4Host (address);
+  m_initialized = true;
 }
 
 Ipv4Address
@@ -265,6 +270,13 @@
 }
 
 bool
+Ipv4Address::IsInitialized (void) const
+{
+  NS_LOG_FUNCTION (this);
+  return (m_initialized);
+}
+
+bool
 Ipv4Address::IsAny (void) const
 {
   NS_LOG_FUNCTION (this);
@@ -326,6 +338,8 @@
   ipv4.m_address |= buf[2];
   ipv4.m_address <<= 8;
   ipv4.m_address |= buf[3];
+  ipv4.m_initialized = true;
+
   return ipv4;
 }
 
@@ -436,15 +450,6 @@
   return is;
 }
 
-bool operator == (Ipv4Mask const &a, Ipv4Mask const &b)
-{
-  return a.IsEqual (b);
-}
-bool operator != (Ipv4Mask const &a, Ipv4Mask const &b)
-{
-  return !a.IsEqual (b);
-}
-
 ATTRIBUTE_HELPER_CPP (Ipv4Address);
 ATTRIBUTE_HELPER_CPP (Ipv4Mask);
 
